Update ServiceNow template

PUT https://api.ap1.datadoghq.com/api/v2/integration/servicenow/handles/{template_id}https://api.ap2.datadoghq.com/api/v2/integration/servicenow/handles/{template_id}https://api.datadoghq.eu/api/v2/integration/servicenow/handles/{template_id}https://api.ddog-gov.com/api/v2/integration/servicenow/handles/{template_id}https://api.us2.ddog-gov.com/api/v2/integration/servicenow/handles/{template_id}https://api.datadoghq.com/api/v2/integration/servicenow/handles/{template_id}https://api.us3.datadoghq.com/api/v2/integration/servicenow/handles/{template_id}https://api.us5.datadoghq.com/api/v2/integration/servicenow/handles/{template_id}

Overview

Update a ServiceNow template by ID.

Arguments

Path Parameters

Name

Type

Description

template_id [required]

string

The ID of the ServiceNow template to update

Request

Body Data (required)

Expand All

Field

Type

Description

data [required]

object

Data object for updating a ServiceNow template

attributes [required]

object

Attributes for updating a ServiceNow template

assignment_group_id

uuid

The ID of the assignment group

business_service_id

uuid

The ID of the business service

fields_mapping

object

Custom field mappings for the template

<any-key>

string

handle_name [required]

string

The handle name of the template

instance_id [required]

uuid

The ID of the ServiceNow instance

servicenow_tablename [required]

string

The name of the destination ServiceNow table

user_id

uuid

The ID of the user

type [required]

enum

Type identifier for ServiceNow template resources Allowed enum values: servicenow_templates

{
  "data": {
    "attributes": {
      "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "fields_mapping": {
        "<any-key>": "string"
      },
      "handle_name": "incident-template-updated",
      "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "servicenow_tablename": "incident",
      "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e"
    },
    "type": "servicenow_templates"
  }
}

Response

OK

Response containing a single ServiceNow template

Expand All

Field

Type

Description

data [required]

object

Data object for a ServiceNow template

attributes [required]

object

Attributes of a ServiceNow template

assignment_group_id

uuid

The ID of the assignment group

business_service_id

uuid

The ID of the business service

fields_mapping

object

Custom field mappings for the template

<any-key>

string

handle_name [required]

string

The handle name of the template

instance_id [required]

uuid

The ID of the ServiceNow instance

servicenow_tablename [required]

string

The name of the destination ServiceNow table

user_id

uuid

The ID of the user

id [required]

uuid

Unique identifier for the ServiceNow template

type [required]

enum

Type identifier for ServiceNow template resources Allowed enum values: servicenow_templates

{
  "data": {
    "attributes": {
      "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "fields_mapping": {
        "<any-key>": "string"
      },
      "handle_name": "incident-template",
      "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "servicenow_tablename": "incident",
      "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e"
    },
    "id": "65b3341b-0680-47f9-a6d4-134db45c603e",
    "type": "servicenow_templates"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  ## default
# 

# Path parameters
export template_id="65b3341b-0680-47f9-a6d4-134db45c603e"
# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/integration/servicenow/handles/${template_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e", "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e", "fields_mapping": { "category": "hardware", "priority": "2" }, "handle_name": "incident-template-updated", "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e", "servicenow_tablename": "incident", "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e" }, "type": "servicenow_templates" } } EOF
"""
Update ServiceNow template returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.service_now_integration_api import ServiceNowIntegrationApi
from datadog_api_client.v2.model.service_now_template_type import ServiceNowTemplateType
from datadog_api_client.v2.model.service_now_template_update_request import ServiceNowTemplateUpdateRequest
from datadog_api_client.v2.model.service_now_template_update_request_attributes import (
    ServiceNowTemplateUpdateRequestAttributes,
)
from datadog_api_client.v2.model.service_now_template_update_request_data import ServiceNowTemplateUpdateRequestData
from uuid import UUID

body = ServiceNowTemplateUpdateRequest(
    data=ServiceNowTemplateUpdateRequestData(
        attributes=ServiceNowTemplateUpdateRequestAttributes(
            assignment_group_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            business_service_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            fields_mapping=dict(
                category="hardware",
                priority="2",
            ),
            handle_name="incident-template-updated",
            instance_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            servicenow_tablename="incident",
            user_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
        ),
        type=ServiceNowTemplateType.SERVICENOW_TEMPLATES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ServiceNowIntegrationApi(api_client)
    response = api_instance.update_service_now_template(
        template_id=UUID("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body=body
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# Update ServiceNow template returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ServiceNowIntegrationAPI.new

body = DatadogAPIClient::V2::ServiceNowTemplateUpdateRequest.new({
  data: DatadogAPIClient::V2::ServiceNowTemplateUpdateRequestData.new({
    attributes: DatadogAPIClient::V2::ServiceNowTemplateUpdateRequestAttributes.new({
      assignment_group_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      business_service_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      fields_mapping: {
        category: "hardware", priority: "2",
      },
      handle_name: "incident-template-updated",
      instance_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      servicenow_tablename: "incident",
      user_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
    }),
    type: DatadogAPIClient::V2::ServiceNowTemplateType::SERVICENOW_TEMPLATES,
  }),
})
p api_instance.update_service_now_template("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// Update ServiceNow template returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.ServiceNowTemplateUpdateRequest{
		Data: datadogV2.ServiceNowTemplateUpdateRequestData{
			Attributes: datadogV2.ServiceNowTemplateUpdateRequestAttributes{
				AssignmentGroupId: datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
				BusinessServiceId: datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
				FieldsMapping: map[string]string{
					"category": "hardware",
					"priority": "2",
				},
				HandleName:          "incident-template-updated",
				InstanceId:          uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e"),
				ServicenowTablename: "incident",
				UserId:              datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
			},
			Type: datadogV2.SERVICENOWTEMPLATETYPE_SERVICENOW_TEMPLATES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewServiceNowIntegrationApi(apiClient)
	resp, r, err := api.UpdateServiceNowTemplate(ctx, uuid.MustParse("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ServiceNowIntegrationApi.UpdateServiceNowTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ServiceNowIntegrationApi.UpdateServiceNowTemplate`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// Update ServiceNow template returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ServiceNowIntegrationApi;
import com.datadog.api.client.v2.model.ServiceNowTemplateResponse;
import com.datadog.api.client.v2.model.ServiceNowTemplateType;
import com.datadog.api.client.v2.model.ServiceNowTemplateUpdateRequest;
import com.datadog.api.client.v2.model.ServiceNowTemplateUpdateRequestAttributes;
import com.datadog.api.client.v2.model.ServiceNowTemplateUpdateRequestData;
import java.util.Map;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ServiceNowIntegrationApi apiInstance = new ServiceNowIntegrationApi(defaultClient);

    ServiceNowTemplateUpdateRequest body =
        new ServiceNowTemplateUpdateRequest()
            .data(
                new ServiceNowTemplateUpdateRequestData()
                    .attributes(
                        new ServiceNowTemplateUpdateRequestAttributes()
                            .assignmentGroupId(
                                UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .businessServiceId(
                                UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .fieldsMapping(
                                Map.ofEntries(
                                    Map.entry("category", "hardware"), Map.entry("priority", "2")))
                            .handleName("incident-template-updated")
                            .instanceId(UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .servicenowTablename("incident")
                            .userId(UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e")))
                    .type(ServiceNowTemplateType.SERVICENOW_TEMPLATES));

    try {
      ServiceNowTemplateResponse result =
          apiInstance.updateServiceNowTemplate(
              UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"), body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling ServiceNowIntegrationApi#updateServiceNowTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// Update ServiceNow template returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_service_now_integration::ServiceNowIntegrationAPI;
use datadog_api_client::datadogV2::model::ServiceNowTemplateType;
use datadog_api_client::datadogV2::model::ServiceNowTemplateUpdateRequest;
use datadog_api_client::datadogV2::model::ServiceNowTemplateUpdateRequestAttributes;
use datadog_api_client::datadogV2::model::ServiceNowTemplateUpdateRequestData;
use std::collections::BTreeMap;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = ServiceNowTemplateUpdateRequest::new(ServiceNowTemplateUpdateRequestData::new(
        ServiceNowTemplateUpdateRequestAttributes::new(
            "incident-template-updated".to_string(),
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
            "incident".to_string(),
        )
        .assignment_group_id(
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
        )
        .business_service_id(
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
        )
        .fields_mapping(BTreeMap::from([
            ("category".to_string(), "hardware".to_string()),
            ("priority".to_string(), "2".to_string()),
        ]))
        .user_id(Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID")),
        ServiceNowTemplateType::SERVICENOW_TEMPLATES,
    ));
    let configuration = datadog::Configuration::new();
    let api = ServiceNowIntegrationAPI::with_config(configuration);
    let resp = api
        .update_service_now_template(
            Uuid::parse_str("00000000-0000-0000-0000-000000000000").expect("invalid UUID"),
            body,
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Update ServiceNow template returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ServiceNowIntegrationApi(configuration);

const params: v2.ServiceNowIntegrationApiUpdateServiceNowTemplateRequest = {
  body: {
    data: {
      attributes: {
        assignmentGroupId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        businessServiceId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        fieldsMapping: {
          category: "hardware",
          priority: "2",
        },
        handleName: "incident-template-updated",
        instanceId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        servicenowTablename: "incident",
        userId: "65b3341b-0680-47f9-a6d4-134db45c603e",
      },
      type: "servicenow_templates",
    },
  },
  templateId: "9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d",
};

apiInstance
  .updateServiceNowTemplate(params)
  .then((data: v2.ServiceNowTemplateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"